from Node import Node
import logging
import Utility
import hashlib
import Config
import random
from ecdsa import SigningKey,SECP256k1
from ecdsa.keys import BadSignatureError

genesisBlock = ("I am the first block")
#
# class Role:
#     def __init__(self):
#         self.role =




class OverlayNode(Node):
    def __init__(self,id,network,weight):
        Node.__init__(self,id,network,weight)


        self.blockchain = [genesisBlock]
        self.tentativeblockchain =  []
        self.currentRound = 1  # round is equivalent ot block height
        self.step = 0
        self.currentRoleCount = 20
        self.currentRole = "BLOCK_PROPOSER"
        self.currentSeed = None
        self.currentPreviousHash = None


        self.startNodeLifeCycleGenerator = self.startNodeLifeCycle()
        # adding initial task of bootstraping node.and it only contains ba* resume tasks
        # self.ResumeTasks.append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.ResumeTasks['1'].append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.commands.update({})

    def printStats(self):
        print('----------------------------------------------------------------------------------------------------------------')
        print(Config.BLOCK_PROPOSAL_MSG_type," : counts : {}".format(len(self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type])))
        print(Config.COMMITTEE_VOTE_MSG_type," : counts : {}".format(len(self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type])))
        print(Config.TENTATIVE_BLOCK_msg_type," : counts : {}".format(len(self.uniqueReceivedMessages[Config.TENTATIVE_BLOCK_msg_type])))
        print(Config.FINALIZED_BLOCK_msg_type," : counts : {}".format(len(self.uniqueReceivedMessages[Config.FINALIZED_BLOCK_msg_type])))
        print("MESSAGES TILL NOW :COUNT : {}".format(len(self.messagesTillNow)))
        print('----------------------------------------------------------------------------------------------------------------')

    # def processMessage(self,time,payload):
    #     super(OverlayNode, self).processMessage(time,payload)
    #     ##print("from overlay node : "+str(payload))


    def committeeVote(self,seed ,round,step,tou,value,fromwhere_it_is_called):
        role = (Config.ROLE_COMMITEE_FOR_VOTE, round, step)
        sorthash, proof, j = Utility.sortition(self.sk, seed,
                                     tou,
                                     role,
                                     self.weight, self.network.badaW,
                                     self.pk)

        if j > 0:
            self.logger.info("selection for VOTING COMMITEE :[ "+ str(fromwhere_it_is_called)+" ] with  J = {}".format(j))
            payload = (
                self.currentRound, step,sorthash,
                proof, self.currentPreviousHash, value)
            committeeVoteMsg = (Config.COMMITTEE_VOTE_MSG_type,
                                                        (self.pk, payload,
                                                         self.sk.sign(bytes(
                                                             str(payload).encode(
                                                                 'UTF8')))))
            self.broadcast(self.network.time, committeeVoteMsg)
            self.logger.info(
                "Broadcasting commitee messgae : ["+fromwhere_it_is_called+" : {}".format(committeeVoteMsg))
        pass


    def algo_processMsg(self,msg,tou):
        pk = msg[1][0]
        sign = msg[1][2]
        payload = msg[1][1]

        try:
            pk.verify(sign,bytes(str(payload).encode('UTF8')) )
        except BadSignatureError as badSign:
            ##print("bad signature")
            return 0,None,None

        round, step, sorthash, proof, previousblockHash, value = payload

        if previousblockHash != hashlib.sha256(self.blockchain[-1].encode('utf-8')).hexdigest() :
            ##print("not in the right chain")
            return 0, None, None


        seed = self.currentSeed
        role= (Config.ROLE_COMMITEE_FOR_VOTE, round, step)
        # Todo something is wrong here not getting correct votes back
        self.logger.info("inputs to verify sort : {}".format((pk, sorthash, proof, seed, tou, role, self.network.pk_weight_map.get(pk), self.network.badaW)))
        votes = Utility.verifySort(pk, sorthash, proof, seed, tou, role, self.network.pk_weight_map.get(pk), self.network.badaW)
        self.logger.info("outpusts of veifysort : {}".format(votes))
        if votes :
            self.logger.info("THese are valid committee votes with votes : "+str(votes))
        ##print(votes,"\t",value,"\t",sorthash)
        return votes,value,sorthash
        pass

    def partOfCountVotes(self,round,step,start,counts,voters,T,tou):
        msgs = self.uniqueReceivedMessages.pop(Config.COMMITTEE_VOTE_MSG_type)
        ##print("-------------msgs , ", self.id)
        #print(msgs)
        for msg in msgs:

            msg_round = msg[1][1][0]
            msg_step = msg[1][1][1]
            payload = msg[1][1]
            msg_pk = msg[1][0]
            # ##print(round, " # ",step )
            if  msg_round== round and msg_step==step : #check if message belong to current round and current step or not
                votes,value,sorthash = self.algo_processMsg(msg,tou)
                if msg_pk in voters  or votes == 0:
                    ##print(self.id + " continuing")
                    continue
                voters.append(msg_pk)
                ##print("yup its wrong here")
                counts[value] = counts.get(value, votes)
                ##print('--------------counts-------------',self.id)
                ##print(counts)
                if counts[value] > T*tou :
                    ##print("returning value")
                    return value

                pass
            else:
                self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].append(msg)
            pass
        pass


    def commonCoin(self,round,step,tou):
        msgs = self.uniqueReceivedMessages.pop(Config.COMMITTEE_VOTE_MSG_type)
        minhash = 2**256
        for msg in msgs:

            msg_round = msg[1][1][0]
            msg_step = msg[1][1][1]
            payload = msg[1][1]
            msg_pk = msg[1][0]
            if  msg_round== round and msg_step==step : #check if message belong to current round and current step or not
                votes,value,sorthash = self.algo_processMsg(msg,tou)
                for i in range(1,votes):
                    input_to_SHA256 = (sorthash, i)
                    temp  = hashlib.sha256((str(input_to_SHA256)).encode('utf-8')).hexdigest()
                    h = int(temp,16)
                    if h < minhash :
                        minhash = h
            else:
                self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].append(msg)
            pass

        return minhash % 2
        pass

    def startNodeLifeCycle(self):
        '''THis is monolithic algorand algorithm for a NOde'''
        self.logger.info("Life cycle started")

        while True:
            #increment round number
            self.logger.info("STARTING ROUND NUMBER : {}".format(self.currentRound))


            blockForBA = None
            # Checking if I am a Block Propser
            previousHash = hashlib.sha256(self.blockchain[-1].encode('utf-8')).hexdigest()
            self.currentPreviousHash = previousHash
            seed = ( previousHash,self.currentRound,0)
            self.currentSeed= (previousHash, self.currentRound, 0)
            self.logger.info("priority sortiion ip : {}".format((self.sk,seed,Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, self.weight, self.network.badaW, self.pk)))
            hash, proof, j = Utility.sortition(self.sk,seed,Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, self.weight, self.network.badaW, self.pk)
            self.logger.info("priority sortition op : {}".format(( hash, proof, j )))

            if j > 0 : # only the block proposer commity mebers can enter here
                self.logger.info("selection for BLOCK PROPOSAL with  J ={}".format(j))
                min_sha_priority = None
                # min_sub_user_index = None
                # msg_to_broadcast = ( currentRound, hash , min_sub_user_index , min_sha_priority )
                for sub_user_index in range(self.weight):
                    input_to_SHA256 = (hash , sub_user_index,)
                    sha256_hash = hashlib.sha256((str(input_to_SHA256)).encode('utf-8')).hexdigest()
                    if not min_sha_priority :
                        min_sha_priority = sha256_hash
                        min_sub_user_index = sub_user_index
                    if sha256_hash < min_sha_priority:
                        min_sha_priority =  sha256_hash
                        min_sub_user_index = sub_user_index


                priority_msg_to_broadcast = ( Config.PRIORITY_MSG_type,self.currentRound, hash , min_sub_user_index , min_sha_priority,proof )
                self.logger.info("broadcsting priority message : {}".format(priority_msg_to_broadcast))
                self.broadcast(self.network.time, priority_msg_to_broadcast)


                self.logger.info("WAITING FOR PRIORITY MESSAGES from others")
                yield "resume",Config.lambda_proposer

                greater_flag = True

                msgs = self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
                msgs.sort(key=lambda priority_msg_other: priority_msg_other[4])
                self.logger.info("Priority proposals from other nodes (number of proposal, proposals) : {}".format((len(msgs),list(map(lambda x: x[4], msgs)))))
                # self.logger.info("Priority proposals from other nodes (number of proposal, proposals) : {}".format((len(msgs),msgs)))
                for priority_msg_other in msgs :
                    if min_sha_priority > priority_msg_other[4]:
                        greater_flag = False

                if greater_flag :
                    self.logger.info("I am the block proposer")
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast : ("BLOCK_PROPOSAL_MSG", previousblockhash,A random string as txns,Nod`s priority payload)
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast = (Config.BLOCK_PROPOSAL_MSG_type,
                                                       previousHash,
                                                       Utility.pseudoRandomGenerator(random.randint(0,1000)),
                                                       priority_msg_to_broadcast[1:])
                    self.logger.info("broadcsting BLOCK Proposal Message : {}".format(BLOCK_PROPOSAL_MSG_to_broadcast))
                    self.broadcast(self.network.time, BLOCK_PROPOSAL_MSG_to_broadcast)
                    blockForBA = (previousHash,BLOCK_PROPOSAL_MSG_to_broadcast[2])
                    self.network.BlocksHashTOBLOCK_MAP[Utility.pseudoRandomGenerator(blockForBA)] = blockForBA
                    self.logger.info('Proposed block : {}'.format(blockForBA))

                else:  # others than block proposers
                    # everybody except highest priority block proposer is waiting for lambda_proposer+ lambda_block 33 seconds
                    yield "resume", Config.lambda_proposer + Config.lambda_block

            else: # others than block proposers
                # everybody is waiting for lambda_proposer+ lambda_block 33 seconds
                self.logger.info("GOING TO SLEEP for {}".format(Config.lambda_proposer+Config.lambda_block))
                yield "resume", Config.lambda_proposer+Config.lambda_block

            # TODO:done : drop any priority messages in queue
            try :
                self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
            except Exception:
                pass

            ######### Performing selection of block BA* ############################
            if not (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type] or blockForBA) :
                blockForBA = (previousHash,"Empty")
                self.network.BlocksHashTOBLOCK_MAP[Utility.pseudoRandomGenerator(blockForBA)] = blockForBA
            elif not blockForBA :
                # Todo select block from highest priority node
                blockForBA = (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][1],
                              self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][2])
                pk = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                hash = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][1]
                proof = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                w = self.network.pk_weight_map.get(pk)
                seed = (previousHash, self.currentRound, 0)
                # TODO verify block proposal

                j = Utility.verifySort(pk, hash, proof, seed, Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, w, self.network.badaW)
                if j :
                    self.logger.info("it is a valid block proposed message with j : {}".format(j))

            #todo : DONE : drop block proposal msges
            try :
                self.uniqueReceivedMessages.pop(Config.BLOCK_PROPOSAL_MSG_type)
            except Exception  as e:
                self.logger.error(e)

            # #print(blockForBA)
            hashof_blockForBA = Utility.pseudoRandomGenerator(blockForBA)
            ######### END : Performing selection of block BA* ############################



            self.printStats()
            '''     START : REDUCTION ALGORITHM       '''

            '''    COmmitte vote reduction step 1'''
            reduct_step_1 = 1
            # reduct_seed = (previousHash, self.currentRound, reduct_step_1)
            reduct_seed = self.currentSeed
            reduct_role_1 = (Config.ROLE_COMMITEE_FOR_VOTE,self.currentRound,reduct_step_1)
            self.logger.info("sortition inside reduction step 1 ip : {}".format((self.sk, reduct_seed, Config.tou_step, reduct_role_1,
                                               self.weight, self.network.badaW, self.pk)))
            reduct_sorthash, reduct_proof, reduct_j = Utility.sortition(self.sk, reduct_seed, Config.tou_step, reduct_role_1,
                                               self.weight, self.network.badaW, self.pk)
            self.logger.info("sortition inside reduction step 1 op : {}".format((reduct_sorthash, reduct_proof, reduct_j )))

            if reduct_j > 0:
                self.logger.info("selection for VOTING COMMITEE with  J ={}".format(reduct_j))
                payload = (self.currentRound,reduct_step_1,reduct_sorthash,reduct_proof,previousHash,hashof_blockForBA)
                committeeVoteMsg = (Config.COMMITTEE_VOTE_MSG_type,(self.pk,payload,self.sk.sign(bytes(str(payload).encode('UTF8')))))
                self.broadcast(self.network.time,committeeVoteMsg)
                self.logger.info("Broadcasting commitee messgae : {}".format(committeeVoteMsg))

            # ##print(self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type])
            yield "resume",Config.lambda_block+Config.lambda_step

            ######## count votes for hblock1 ###########
            countVote_round = self.currentRound
            countVote_reduct_step_1 = 1
            # Config.T
            # Config.tou_step
            countVote_lmbda = Config.lambda_block+Config.lambda_step


            start = int(self.network.time)
            counts = {}
            voters = []
            hblock1 = None
            while True:
                if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type] :
                    if int(self.network.time) > start + countVote_lmbda:
                        ##print(self.id + "Timing out")
                        hblock1 = Config.TIMEOUT
                        break
                    pass
                else:
                    temp_return = self.partOfCountVotes(countVote_round,countVote_reduct_step_1,start,counts,voters,Config.T,Config.tou_step)
                    ##print("temp_retiurn " ,temp_return)
                    if temp_return :
                        hblock1 = temp_return
                        break
                yield "resume",1 # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
            self.logger.info("returning from first count values with return value : {}".format(hblock1))
            ##print("returning from first count values with return value",hblock1)

            self.logger.info("votes count reduction step 1 : {}".format(counts))

            ######## END : count votes for hblock1 ###########
            self.printStats()
            self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
            yield 'resume',50
            '''    END : COmmitte vote reduction step 1'''

            ''' Start : COmmitte vote reduction step 2 '''
            empty_hash = Utility.pseudoRandomGenerator((previousHash, "Empty"))

            # which block to vote empty or hblock1
            reduct_step2_block_to_vote = None
            if hblock1 == Config.TIMEOUT :
                reduct_step2_block_to_vote = empty_hash
                self.logger.info("consensus for block in reduction step 1 : {}".format((previousHash, "Empty")))
                pass
            else:
                reduct_step2_block_to_vote = hblock1
                self.logger.info("consensus for block in reduction step 1 : {}".format(reduct_step2_block_to_vote))
                pass



            '''    COmmitte vote reduction step2 : reduct_step2_block_to_vote'''

            variables_reduct_step_2 = {}

            variables_reduct_step_2['step'] = 2
            # variables_reduct_step_2['seed'] = (previousHash, self.currentRound, variables_reduct_step_2['step'])
            variables_reduct_step_2['seed'] = self.currentSeed
            variables_reduct_step_2['role'] = (
            Config.ROLE_COMMITEE_FOR_VOTE, self.currentRound, variables_reduct_step_2['step'])
            variables_reduct_step_2['sorthash'], variables_reduct_step_2['proof'], variables_reduct_step_2[
                'j'] = Utility.sortition(self.sk, variables_reduct_step_2['seed'],
                                         Config.tou_step,
                                         variables_reduct_step_2['role'],
                                         self.weight, self.network.badaW,
                                         self.pk)
            # ##print("Reduction algo " + self.id," : ",reduct_j)

            if variables_reduct_step_2['j'] > 0:
                self.logger.info("selection for VOTING COMMITEE with  J =" + str(variables_reduct_step_2['j']))
                variables_reduct_step_2['payload'] = (
                    self.currentRound, variables_reduct_step_2['step'], variables_reduct_step_2['sorthash'],
                    variables_reduct_step_2['proof'], previousHash, reduct_step2_block_to_vote)
                variables_reduct_step_2['committeeVoteMsg'] = (Config.COMMITTEE_VOTE_MSG_type,
                                                               (self.pk, variables_reduct_step_2['payload'],
                                                                self.sk.sign(bytes(
                                                                    str(variables_reduct_step_2['payload']).encode(
                                                                        'UTF8')))))
                self.broadcast(self.network.time, variables_reduct_step_2['committeeVoteMsg'])
                self.logger.info("Broadcasting commitee messgae" + str(variables_reduct_step_2['committeeVoteMsg']))

            # yield "resume", Config.lambda_block + Config.lambda_step

            '''    COmmitte vote reduction step2 : reduct_step2_block_to_vote'''

            ######## count votes for hblock1 ###########
            CountVotes_step2 = {}
            CountVotes_step2['countVote_round'] = self.currentRound
            CountVotes_step2['countVote_step'] = 2
            # Config.T
            # Config.tou_step
            CountVotes_step2['countVote_lmbda'] = Config.lambda_block + Config.lambda_step

            CountVotes_step2['start'] = int(self.network.time)
            CountVotes_step2['counts'] = {}
            CountVotes_step2['voters'] = []
            CountVotes_step2['hblock2'] = None
            while True:
                if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                    if int(self.network.time) > CountVotes_step2['start'] + CountVotes_step2[
                        'countVote_lmbda']:
                        ##print(self.id + "Timing out")
                        CountVotes_step2['hblock2'] = Config.TIMEOUT
                        break
                    pass
                else:
                    CountVotes_step2['temp_return'] = self.partOfCountVotes(
                        CountVotes_step2['countVote_round'], CountVotes_step2['countVote_step'],
                        CountVotes_step2['start'], CountVotes_step2['counts'],
                        CountVotes_step2['voters'], Config.T, Config.tou_step)
                    #print("CountVotes_step2",CountVotes_step2['temp_return'])
                    if CountVotes_step2['temp_return']:
                        CountVotes_step2['hblock2'] = CountVotes_step2['temp_return']
                        break
                yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
            self.logger.info(
                "returning from first count values with return value : " + str(CountVotes_step2['hblock2']))
            #print("CountVotes_step2",CountVotes_step2['hblock2'])

            ######## END : count votes for hblock1 ###########

            var_BBA_star = {}
            #print('++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
            if CountVotes_step2['hblock2'] == Config.TIMEOUT:
                var_BBA_star['block_hash']= empty_hash
            else:
                var_BBA_star['block_hash'] = CountVotes_step2['hblock2']


            #print("I am culprit " )
            #print(var_BBA_star['block_hash'])
            self.printStats()
            # self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
            yield 'resume', 50
            ''' END : COmmitte vote reduction step 2 '''

            '''     END : REDUCTION ALGORITHM       '''








            '''    START : BBA* ALGORITHM  '''

            var_BBA_star['step'] = 1
            var_BBA_star['r'] = var_BBA_star['block_hash']
            var_BBA_star['empty_hash'] = Utility.pseudoRandomGenerator((previousHash, "Empty"))
            while var_BBA_star['step'] < Config.MAXSTEP :

                '''    COmmitte vote BBA_CASE_1 : BBA_CASE_1'''
                self.committeeVote(self.currentSeed,
                                   self.currentRound,
                                   var_BBA_star['step'],
                                   Config.tou_step,
                                   var_BBA_star['r'],
                                   'BBA_CASE_1')

                '''    COmmitte vote BBA_CASE_1 :BBA_CASE_1'''

                ######## count votes for CountVotes_BBA_CASE_1 ###########
                CountVotes_BBA_CASE_1 = {}
                CountVotes_BBA_CASE_1['countVote_round'] = self.currentRound
                CountVotes_BBA_CASE_1['countVote_step'] = var_BBA_star['step']
                # Config.T
                # Config.tou_step
                CountVotes_BBA_CASE_1['countVote_lmbda'] = Config.lambda_step

                CountVotes_BBA_CASE_1['start'] = int(self.network.time)
                CountVotes_BBA_CASE_1['counts'] = {}
                CountVotes_BBA_CASE_1['voters'] = []
                CountVotes_BBA_CASE_1['return_block_hash'] = None
                while True:
                    if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                        if int(self.network.time) > CountVotes_BBA_CASE_1['start'] + CountVotes_BBA_CASE_1[
                            'countVote_lmbda']:
                            #print(self.id + "Timing out")
                            CountVotes_BBA_CASE_1['return_block_hash'] = Config.TIMEOUT
                            break
                        pass
                    else:
                        CountVotes_BBA_CASE_1['temp_return'] = self.partOfCountVotes(
                            CountVotes_BBA_CASE_1['countVote_round'], CountVotes_BBA_CASE_1['countVote_step'],
                            CountVotes_BBA_CASE_1['start'], CountVotes_BBA_CASE_1['counts'],
                            CountVotes_BBA_CASE_1['voters'], Config.T, Config.tou_step)
                        #print("CountVotes_BBA_CASE_1", CountVotes_BBA_CASE_1['temp_return'])
                        if CountVotes_BBA_CASE_1['temp_return']:
                            CountVotes_BBA_CASE_1['return_block_hash'] = CountVotes_BBA_CASE_1['temp_return']
                            break
                    yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
                self.logger.info("CountVotes_BBA_CASE_1 o/p : {}".format( CountVotes_BBA_CASE_1['return_block_hash']))
                #print("CountVotes_BBA_CASE_1", CountVotes_BBA_CASE_1['return_block_hash'])

                var_BBA_star['r'] = CountVotes_BBA_CASE_1['return_block_hash']
                self.printStats()
                # self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
                yield 'resume', 50
                ######## END : count votes for CountVotes_BBA_CASE_1 ###########

                if var_BBA_star['r'] == Config.TIMEOUT :
                    var_BBA_star['r'] = var_BBA_star['block_hash']
                elif var_BBA_star['r'] != var_BBA_star['empty_hash'] :
                    for i in range(1,4):
                        self.committeeVote(self.currentSeed,
                                           self.currentRound,
                                           var_BBA_star['step']+i,
                                           Config.tou_step,
                                           var_BBA_star['r'],
                                           'BBA_CASE_1_if_not_emptyhashCase')
                    if  var_BBA_star['step'] == 1:
                        self.committeeVote(self.currentSeed,
                                           self.currentRound,
                                           Config.FINAL_STEP,
                                           Config.tou_step,
                                           var_BBA_star['r'],
                                           'BBA_CASE_1_Reached final consensu in step 1')

                    var_BBA_star['return_value'] = var_BBA_star['r']
                    break


                    pass
                var_BBA_star['step'] += 1

                self.printStats()
                ''' START : BBAstar_case 2'''

                '''    COmmitte vote BBA_CASE_2 : BBA_CASE_2'''
                self.committeeVote(self.currentSeed,
                                   self.currentRound,
                                   var_BBA_star['step'],
                                   Config.tou_step,
                                   var_BBA_star['r'],
                                   'BBA_CASE_2')

                '''    COmmitte vote BBA_CASE_2 :BBA_CASE_2'''

                ######## count votes for CountVotes_BBA_CASE_2 ###########
                CountVotes_BBA_CASE_2 = {}
                CountVotes_BBA_CASE_2['countVote_round'] = self.currentRound
                CountVotes_BBA_CASE_2['countVote_step'] = var_BBA_star['step']
                # Config.T
                # Config.tou_step
                CountVotes_BBA_CASE_2['countVote_lmbda'] = Config.lambda_step

                CountVotes_BBA_CASE_2['start'] = int(self.network.time)
                CountVotes_BBA_CASE_2['counts'] = {}
                CountVotes_BBA_CASE_2['voters'] = []
                CountVotes_BBA_CASE_2['return_block_hash'] = None
                while True:
                    if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                        if int(self.network.time) > CountVotes_BBA_CASE_2['start'] + CountVotes_BBA_CASE_2[
                            'countVote_lmbda']:
                            #print(self.id + "Timing out")
                            CountVotes_BBA_CASE_2['return_block_hash'] = Config.TIMEOUT
                            break
                        pass
                    else:
                        CountVotes_BBA_CASE_2['temp_return'] = self.partOfCountVotes(
                            CountVotes_BBA_CASE_2['countVote_round'], CountVotes_BBA_CASE_2['countVote_step'],
                            CountVotes_BBA_CASE_2['start'], CountVotes_BBA_CASE_2['counts'],
                            CountVotes_BBA_CASE_2['voters'], Config.T, Config.tou_step)
                        #print("CountVotes_BBA_CASE_2", CountVotes_BBA_CASE_2['temp_return'])
                        if CountVotes_BBA_CASE_2['temp_return']:
                            CountVotes_BBA_CASE_2['return_block_hash'] = CountVotes_BBA_CASE_2['temp_return']
                            break
                    yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
                self.logger.info("CountVotes_BBA_CASE_2 o/p : {}".format(CountVotes_BBA_CASE_2['return_block_hash']))
                #print("CountVotes_BBA_CASE_2", CountVotes_BBA_CASE_2['return_block_hash'])

                var_BBA_star['r'] = CountVotes_BBA_CASE_2['return_block_hash']

                ######## END : count votes for CountVotes_BBA_CASE_2 ###########

                if var_BBA_star['r'] == Config.TIMEOUT:
                    var_BBA_star['r'] = var_BBA_star['block_hash']
                elif var_BBA_star['r'] != var_BBA_star['empty_hash']:
                    for i in range(1, 4):
                        self.committeeVote(self.currentSeed,
                                           self.currentRound,
                                           var_BBA_star['step'] + i,
                                           Config.tou_step,
                                           var_BBA_star['r'],
                                           'BBA_CASE_2_if_not_emptyhashCase')
                        pass
                    var_BBA_star['return_value'] = var_BBA_star['r']
                    break
                    pass

                var_BBA_star['step'] += 1
                self.printStats()
                # self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
                yield 'resume', 50
                ''' END : BBAstar_case 2'''

                '''START : BBAStar case 3'''
                '''    COmmitte vote BBA_CASE_3 : BBA_CASE_3'''
                self.committeeVote(self.currentSeed,
                                   self.currentRound,
                                   var_BBA_star['step'],
                                   Config.tou_step,
                                   var_BBA_star['r'],
                                   'BBA_CASE_3')

                '''    COmmitte vote BBA_CASE_3 :BBA_CASE_3'''

                ######## count votes for CountVotes_BBA_CASE_3 ###########
                CountVotes_BBA_CASE_3 = {}
                CountVotes_BBA_CASE_3['countVote_round'] = self.currentRound
                CountVotes_BBA_CASE_3['countVote_step'] = var_BBA_star['step']
                # Config.T
                # Config.tou_step
                CountVotes_BBA_CASE_3['countVote_lmbda'] = Config.lambda_step

                CountVotes_BBA_CASE_3['start'] = int(self.network.time)
                CountVotes_BBA_CASE_3['counts'] = {}
                CountVotes_BBA_CASE_3['voters'] = []
                CountVotes_BBA_CASE_3['return_block_hash'] = None
                while True:
                    if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                        if int(self.network.time) > CountVotes_BBA_CASE_3['start'] + CountVotes_BBA_CASE_3[
                            'countVote_lmbda']:
                            #print(self.id + "Timing out")
                            CountVotes_BBA_CASE_3['return_block_hash'] = Config.TIMEOUT
                            break
                        pass
                    else:
                        CountVotes_BBA_CASE_3['temp_return'] = self.partOfCountVotes(
                            CountVotes_BBA_CASE_3['countVote_round'], CountVotes_BBA_CASE_3['countVote_step'],
                            CountVotes_BBA_CASE_3['start'], CountVotes_BBA_CASE_3['counts'],
                            CountVotes_BBA_CASE_3['voters'], Config.T, Config.tou_step)
                        #print("CountVotes_BBA_CASE_3", CountVotes_BBA_CASE_3['temp_return'])
                        if CountVotes_BBA_CASE_3['temp_return']:
                            CountVotes_BBA_CASE_3['return_block_hash'] = CountVotes_BBA_CASE_3['temp_return']
                            break
                    yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
                self.logger.info("CountVotes_BBA_CASE_3 o/p : {}".format(CountVotes_BBA_CASE_3['return_block_hash']))
                #print("CountVotes_BBA_CASE_3", CountVotes_BBA_CASE_3['return_block_hash'])

                var_BBA_star['r'] = CountVotes_BBA_CASE_3['return_block_hash']

                ######## END : count votes for CountVotes_BBA_CASE_3 ###########





                if var_BBA_star['r'] == Config.TIMEOUT:



                    if self.commonCoin(self.currentRound,var_BBA_star['step'],Config.tou_step) :
                        var_BBA_star['r'] = var_BBA_star['block_hash']
                    else :
                        var_BBA_star['r'] = var_BBA_star['empty_hash']
                        pass

                var_BBA_star['step'] += 1
                self.printStats()
                # self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
                yield "resume", 50
                '''END : BBAStar case 3'''


                yield "resume",1

            if var_BBA_star['step'] == Config.MAXSTEP :
                self.logger.info("I AM GOING TO HANG FOREVER")
                yield "resume", 40120000 # hang forever
                # exit(0)

            '''    END : BBA* ALGORITHM  '''

            hblockSTAR = var_BBA_star['return_value']

            ######## count votes for CountVotes_FINAL ###########
            CountVotes_FINAL = {}
            CountVotes_FINAL['countVote_round'] = self.currentRound
            CountVotes_FINAL['countVote_step'] = Config.FINAL_STEP
            # Config.T
            # Config.tou_step
            CountVotes_FINAL['countVote_lmbda'] = Config.lambda_step

            CountVotes_FINAL['start'] = int(self.network.time)
            CountVotes_FINAL['counts'] = {}
            CountVotes_FINAL['voters'] = []
            CountVotes_FINAL['return_block_hash'] = None
            while True:
                if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                    if int(self.network.time) > CountVotes_FINAL['start'] + CountVotes_FINAL[
                        'countVote_lmbda']:
                        ##print(self.id + "Timing out")
                        CountVotes_FINAL['return_block_hash'] = Config.TIMEOUT
                        break
                    pass
                else:
                    CountVotes_FINAL['temp_return'] = self.partOfCountVotes(
                        CountVotes_FINAL['countVote_round'], CountVotes_FINAL['countVote_step'],
                        CountVotes_FINAL['start'], CountVotes_FINAL['counts'],
                        CountVotes_FINAL['voters'], Config.T_FINAL, Config.tou_FINAL)
                    ##print("CountVotes_FINAL", CountVotes_FINAL['temp_return'])
                    if CountVotes_FINAL['temp_return']:
                        CountVotes_FINAL['return_block_hash'] = CountVotes_FINAL['temp_return']
                        break
                yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
            self.logger.info("CountVotes_FINAL o/p : {}".format(CountVotes_FINAL['return_block_hash']))
            ##print("CountVotes_FINAL", CountVotes_FINAL['return_block_hash'])


            ######## END : count votes for CountVotes_FINAL ###########

            if hblockSTAR == CountVotes_FINAL['return_block_hash']:
                FNALIZED_BLOCK_msg = (
                Config.FINALIZED_BLOCK_msg_type,hblockSTAR )
                self.logger.info("FINALIZED BLOCK in round :"+str(self.currentRound)+" : {}".format(FNALIZED_BLOCK_msg))
                self.blockchain.append(str(self.network.BlocksHashTOBLOCK_MAP[hblockSTAR]))
            else:
                TENTATIVE_BLOCK_msg = (Config.TENTATIVE_BLOCK_msg_type, hblockSTAR)
                self.logger.info("TENTATIVE BLOCK in round :"+str(self.currentRound)+" : {}".format(TENTATIVE_BLOCK_msg))
                self.tentativeblockchain.append(str(self.network.BlocksHashTOBLOCK_MAP[hblockSTAR]))
            self.logger.info("BLOCKCHAIN : {}".format(self.blockchain))

            self.printStats()
            self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].clear()
            self.messagesTillNow.clear()
            self.logger.info("PROPOSED BLOCKS IN ROUND :"+str(self.currentRound)+" : {} ".format(self.network.BlocksHashTOBLOCK_MAP))
            self.network.BlocksHashTOBLOCK_MAP.clear()
            yield 'resume', 10
            print("stats for experiment 1 : {}".format(Config.Experiment_1_OBS))
            self.currentRound = self.currentRound + 1


            # self.logger.info(self.uniqueReceivedMessages)





            '''
             TODo check if node is selected as BLOCK_PROPOSER
                if yes 
                then
                    select highest priority subuser and gossip the message
                    wait for lambda_proposer=3 sec and hear other block propositions
                    take decision based on received propositions and determine if himself is a highest priority or not
                    if yes
                        broacast the block proposal <format of block proposal>
                
                everybody except highest priority block proposer waits for  t_proposer+t_block time to here the proposed block
                    if received proposal
                    then 
                        start BA* with this new block
                        validate sortition of proposed block
                        if yes
                        then
                            start reduction
                        else 
                            vote for empty block
                    else 
                        start BA* with empty block
                
                
                        
                        
            '''


            pass
        self.ResumeTasks[str(int(self.network.time)+10)].append(("nextOn", self.startNodeLifeCycleGenerator,))

        pass



















def m(v):
    v.append('ganesh')



def takeSecond(elem):
   return elem[1]


if __name__ == '__main__':
    x =  ['I am the first block', "('812a53b631914a36764fc9f8328dd019ce50f5c4b6051f670fbe0efb705efc77', 84736415767811103652304891014813354728426533548611541614918993721182826986444)", "('d31fbe19c2e713985ecdf394969c7790d19a87dcafa9c02cba0558bf12d544d4', 103122347745550455001943383981344366012988901432495847445355962900079905936198)", "('fd5a205348d15fc21b256ebd303a135857bda77a1993cf11303e45785aefb332', 47823573000215416532528435656381159431075140417141700821011381942532282748521)", "('9c868518b4d10e1a4a13046f6097f97d6df6dc1e95a661953d527a823ee6f050', 55460601694948737718196781018048019511931736228223657848800923874020053551928)", "('c2a3b56930d43645a93e865782abb0b4bac6681e693c9d50c13fd7391b4b7f25', 58707674458812810357241716928176455160340351916543706621213043845025913695452)", "('b03f15d0e7782a7f95fab6617411aa03f21cd9229e8e4f242ea4079ecd920cc2', 67573794190754323804116586417572734088575374646300010693539061879295897305162)", "('98d98b0732f5c5218a3b2ad49b5cba8c7d17c996ff4ea5689937684f2b20d79d', 69633357725200221165001650735647103204316958836713683487178046118094356870936)", "('9f4af3721891d947075907ba44c0d3587a6be51214b56be4478cbbfb54d5d88b', 66422139942822171704688570027380253905979677843036084427158008574677456200809)", "('86231ce45686fdafc82dc4159ba710e3f8b7fa31cf78dd25dcb8dfca313b4ac2', 108471944712883743347571235551646957426255157519283101098519720665762066857519)"]
    y =  ['I am the first block', "('812a53b631914a36764fc9f8328dd019ce50f5c4b6051f670fbe0efb705efc77', 84736415767811103652304891014813354728426533548611541614918993721182826986444)", "('d31fbe19c2e713985ecdf394969c7790d19a87dcafa9c02cba0558bf12d544d4', 103122347745550455001943383981344366012988901432495847445355962900079905936198)", "('fd5a205348d15fc21b256ebd303a135857bda77a1993cf11303e45785aefb332', 47823573000215416532528435656381159431075140417141700821011381942532282748521)", "('9c868518b4d10e1a4a13046f6097f97d6df6dc1e95a661953d527a823ee6f050', 55460601694948737718196781018048019511931736228223657848800923874020053551928)", "('c2a3b56930d43645a93e865782abb0b4bac6681e693c9d50c13fd7391b4b7f25', 58707674458812810357241716928176455160340351916543706621213043845025913695452)", "('b03f15d0e7782a7f95fab6617411aa03f21cd9229e8e4f242ea4079ecd920cc2', 67573794190754323804116586417572734088575374646300010693539061879295897305162)", "('98d98b0732f5c5218a3b2ad49b5cba8c7d17c996ff4ea5689937684f2b20d79d', 69633357725200221165001650735647103204316958836713683487178046118094356870936)", "('9f4af3721891d947075907ba44c0d3587a6be51214b56be4478cbbfb54d5d88b', 66422139942822171704688570027380253905979677843036084427158008574677456200809)", "('86231ce45686fdafc82dc4159ba710e3f8b7fa31cf78dd25dcb8dfca313b4ac2', 108471944712883743347571235551646957426255157519283101098519720665762066857519)"]
    ['I am the first block',
     "('812a53b631914a36764fc9f8328dd019ce50f5c4b6051f670fbe0efb705efc77', 84736415767811103652304891014813354728426533548611541614918993721182826986444)",
     "('d31fbe19c2e713985ecdf394969c7790d19a87dcafa9c02cba0558bf12d544d4', 103122347745550455001943383981344366012988901432495847445355962900079905936198)",
     "('fd5a205348d15fc21b256ebd303a135857bda77a1993cf11303e45785aefb332', 47823573000215416532528435656381159431075140417141700821011381942532282748521)",
     "('9c868518b4d10e1a4a13046f6097f97d6df6dc1e95a661953d527a823ee6f050', 55460601694948737718196781018048019511931736228223657848800923874020053551928)",
     "('c2a3b56930d43645a93e865782abb0b4bac6681e693c9d50c13fd7391b4b7f25', 58707674458812810357241716928176455160340351916543706621213043845025913695452)",
     "('b03f15d0e7782a7f95fab6617411aa03f21cd9229e8e4f242ea4079ecd920cc2', 67573794190754323804116586417572734088575374646300010693539061879295897305162)",
     "('98d98b0732f5c5218a3b2ad49b5cba8c7d17c996ff4ea5689937684f2b20d79d', 69633357725200221165001650735647103204316958836713683487178046118094356870936)",
     "('9f4af3721891d947075907ba44c0d3587a6be51214b56be4478cbbfb54d5d88b', 66422139942822171704688570027380253905979677843036084427158008574677456200809)",
     "('86231ce45686fdafc82dc4159ba710e3f8b7fa31cf78dd25dcb8dfca313b4ac2', 108471944712883743347571235551646957426255157519283101098519720665762066857519)"]
    print(len(x))


























